<?php
/*
@file: inc/thumbs.php
@description: image thumbnail.
@created: 2009-09-01
@modified: 2009-09-22

    EKO WORDPRESS EXTRAS
    Extra funcionalities for Wordpress blogs.
    Copyright (C) 2009  Igo Santos <web@igosantos.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

include("config.php");

$width= (isset($_GET["w"])) ? $_GET["w"] : 100 ;
$height= (isset($_GET["h"])) ? $_GET["h"] : 100 ;
$image_path = $_GET["img"];
$extensao = strtolower(end(explode('.',$image_path))); 
$quality = (isset($_GET["q"])) ? $_GET["q"] : 50 ;

define('MAX_WIDTH', $width); 
define('MAX_HEIGHT', $height); 


if ($extensao == 'jpg' || $extensao == 'jpeg')
{ 
	$img = @imagecreatefromjpeg($image_path); 
}
else if ($extensao == 'png') 
{ 
	$img = @imagecreatefrompng($image_path);
}
elseif ($extensao == 'gif')
{ 
	$img = @imagecreatefromgif($image_path); 
} 

// Se a imagem foi carregada com sucesso, testa o tamanho da mesma 
if ($img)
{ 
	// Pega o tamanho da imagem e proporção de resize 
	$width = imagesx($img); 
	$height = imagesy($img); 
	$scale = min(MAX_WIDTH/$width, MAX_HEIGHT/$height); 

	// Se a imagem é maior que o permitido, encolhe ela! 
	if ($scale < 1)
	{ 
		$new_width = floor($scale * $width); 
		$new_height = floor($scale * $height); 
	}
	else
	{
		$new_width = $width;
		$new_height = $height; 
	};

	// Cria uma imagem temporária 
	$tmp_img = imagecreatetruecolor($new_width, $new_height); 
	
	// Copia e resize a imagem velha na nova 
	imagecopyresized($tmp_img, $img, 0, 0, 0, 0, $new_width, $new_height, $width, $height); 
	imagedestroy($img); 
	$img = $tmp_img; 
	
} 

// Cria uma imagem de erro se necessário 
if (!$img)
{ 
	$img = imagecreate(MAX_WIDTH, MAX_HEIGHT); 
	imagecolorallocate($img, 204, 204, 204); 
	$c = imagecolorallocate($img, 153, 153, 153); 
	$c1 = imagecolorallocate($img, 0, 0, 0); 
	imageline($img, 0, 0, MAX_WIDTH, MAX_HEIGHT, $c); 
	imageline($img, MAX_WIDTH, 0, 0, MAX_HEIGHT, $c); 
	imagestring($img, 2, 12, 55, 'erro ao carregar imagem', $c1); 
} 

// Mostra a imagem 

header('Content-type: image/jpeg'); 
imagejpeg($img,NULL,$quality); 
 
//mysql_close($dbconn); 
?>
