<?
/*
@file: inc/tools.php
@description: core tools and functions for the plugin.
@created: 2009-09-01
@modified: 2009-12-16

	EKO WORDPRESS EXTRAS
	Extra funcionalities for Wordpress blogs.
    Copyright (C) 2009  Igo Santos <web@igosantos.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//where the program starts...
function eko_start()
{
	//including modules sources and functions
	eko_include_mods();
	
	//add the module main filters
	eko_add_filters();
	
	//matching wordpress hooks
	add_action("loop_end","eko_loop_end");
	add_action("wp_head","eko_style_tag");
	add_action("wp_head","eko_script_tag");
	add_action("admin_head","eko_style_tag");
	add_action("admin_head","eko_script_tag");
	
	//catching hooks
	do_action("eko_init");
}

function eko_init()
{
	load_plugin_textdomain("eko",false,"eko/lang");
};

//run at plugin activation
function eko_activate()
{
	//eko_update_pages();
}

//run at plugin deactivation
function eko_deactivate()
{
};

//creates or updates the module pages.
function eko_update_pages()
{
	global $wpdb, $user_level, $wp_rewrite, $wp_version;
	
	$post_date =date("Y-m-d H:i:s");
	$post_date_gmt =gmdate("Y-m-d H:i:s");
	
	$modules = eko_get_modules_info();
	
	$active_modules = explode(",",get_option("eko_active_modules"));
	$modules = eko_get_modules_info();
	$num=0;
	//echo "<ul class=\"eko_ul\">";
	foreach($modules as $module)
	{
		if(eko_is_module_activated($module["module"]))
		{
			$pages[$num]['name'] = 'eko-'.$module["module"];
			$pages[$num]['title'] = $module["name"];
			$pages[$num]['tag'] = '[eko_'.$module["module"].']';
			$pages[$num]['option'] = 'eko_'.$module["module"].'_permalink';
			//echo "<li>".$pages[$num]['name']." - ".$pages[$num]['title']." - ".$pages[$num]['tag']." - ".$pages[$num]['option']."</li>";
			$num++;
		}
	};
	//echo "</ul>";
	
	//linebreakToTag(print_r($pages));
	
	$newpages = false;
	$i = 0;
	$post_parent = 0;
	
	echo "<ul class=\"eko_ul\">";
	
	// for each page defined in $pages array...
	foreach($pages as $page)
	{
		echo "<li>";
		printf(__("Creating page for &quot;%s&quot; module...","eko"),$page['name']);
		echo "&nbsp;";
		
		//check if the page exists in the database
		$check_page = $wpdb->get_row("SELECT * FROM `".$wpdb->posts."` WHERE `post_content` LIKE '%".$page['tag']."%'  AND `post_type` NOT IN('revision') LIMIT 1",ARRAY_A);
		
		//if not,
		if($check_page == null)
		{
			// lets define the QUERY
			if($wp_version >= 2.1)
			{
				$sql ="INSERT INTO ".$wpdb->posts."
				(post_author, post_date, post_date_gmt, post_content, post_content_filtered, post_title, post_excerpt,  post_status, comment_status, ping_status, post_password, post_name, to_ping, pinged, post_modified, post_modified_gmt, post_parent, menu_order, post_type)
				VALUES
				('1', '$post_date', '$post_date_gmt', '".$page['tag']."', '', '".$page['title']."', '', 'publish', 'closed', 'closed', '', '".$page['name']."', '', '', '$post_date', '$post_date_gmt', '$post_parent', '0', 'page')";
			}
			//query for older versions
			else
			{      
				$sql ="INSERT INTO ".$wpdb->posts."
				(post_author, post_date, post_date_gmt, post_content, post_content_filtered, post_title, post_excerpt,  post_status, comment_status, ping_status, post_password, post_name, to_ping, pinged, post_modified, post_modified_gmt, post_parent, menu_order)
				VALUES
				('1', '$post_date', '$post_date_gmt', '".$page['tag']."', '', '".$page['title']."', '', 'static', 'closed', 'closed', '', '".$page['name']."', '', '', '$post_date', '$post_date_gmt', '$post_parent', '0')";
			}
			
			//echo "<li>".$page['name']." - ".$page['title']." - ".$page['tag']." - ".$page['option']." - ".$sql."</li>";
			
			//execute query!
			$wpdb->query($sql);
			
			//get the database insert id
			$post_id = $wpdb->insert_id;
			
			//??
			$wpdb->query("UPDATE $wpdb->posts SET guid = '" . get_permalink($post_id) . "' WHERE ID = '$post_id'");
			
			//update permalink option
			update_option($page['option'],  get_permalink($post_id));
			
			//set a flag
			$newpages = true;
			
			$i++;
			printf(__('Page created successfully. Click <a href="%s">here</a> to access it.','eko'),get_permalink($post_id));
		}
		else
		{
			printf(__('The page already exists. Click <a href="%s">here</a> to access it.','eko'),get_permalink($check_page['ID']));
		};
		echo "</li>";
	};
	echo "</ul>";
	
	if($newpages == true)
	{
		//update WP cache
		wp_cache_delete('all_page_ids', 'pages');
		$wp_rewrite->flush_rules();
	}

};

//get and returns the output buffer from a defined function
function eko_return_ob($func)
{
	ob_start();
	$func();
	$ret = ob_get_contents();
	ob_end_clean();
	return $ret;
};

//add the module filters. example: if a page have the string "[eko_$module]"
//in its contents, so add the function "eko_$module()" to the filter "the_content"
function eko_add_filters()
{
	function eko_add_filters_function($content)
	{
		global $post;
		
		$actions = eko_get_actions();
		for($i=0;$i<count($actions);$i++)
		{
			if(strpos($content,"[".$actions[$i]."]")>0)
			{
				$content = str_replace("[".$actions[$i]."]",eko_return_ob($actions[$i]),$content);
				//return $content;
			};
		};		
		
		return $content;
	};
	
	add_filter("the_content","eko_add_filters_function");
};

//check for modules in the module path, and then require them.
function eko_include_mods()
{
	$tmpdir = EKO_PLUGIN_DIR . "mod/";
	if (is_dir($tmpdir))
	{
		$tmpdirhandler = opendir($tmpdir);
		while($diritem = readdir($tmpdirhandler))
		{
			
			if (is_file("$tmpdir$diritem")&&(strpos($diritem,"mod.")!==false)&&(strpos($diritem,"mod.")==0))
			{
				include_once("$tmpdir$diritem");
			};
		}
		closedir($tmpdirhandler);
	};
	
};

//execute a trigger at the wordpress loop end
function eko_loop_end()
{
};

//execute a action/function if its module is active
function eko_do_action($action_name)
{
	//TODO: check if the module is active!
	//TODO: check if the function is an configured action
	if(function_exists($action_name)) $action_name();
};

//[deprecated!!]
//returns the action's name string previously associated with a page or post. [deprecated!]
function eko_get_action_from_page($page_id)
{
	$sql = "SELECT action_name FROM ".EKO_DB_PREFIX."eko_actions_x_pages WHERE page_id= '$page_id'";
	if($rs = mysql_query($sql))
	{
		$arr = mysql_fetch_array($rs);
		return $arr["action_name"];
	}
	else
	{
		//TODO: no caso de erro, verificar se as tabelas esto instaladas.
		//echo mysql_error();
		return "";
	}
	return "";
};

//read a file and search for module data, returning an array.
function eko_get_moduledata($file)
{
	$str = implode( '', file( $file ) );
	$str = str_replace ( '\r', '\n', $str );

	$module = (preg_match('| \* @module:(.*)$|mi',$str,$arr)) ? trim($arr[1]) : "-" ;
	$name = (preg_match('| \* @name:(.*)$|mi',$str,$arr)) ? trim($arr[1]) : "-" ;
	$description = (preg_match('| \* @description:(.*)$|mi',$str,$arr)) ? trim($arr[1]) : "-" ;
	$version = (preg_match('| \* @version:(.*)$|mi',$str,$arr)) ? trim($arr[1]) : "-" ;
	$created = (preg_match('| \* @created:(.*)$|mi',$str,$arr)) ? trim($arr[1]) : "-" ;
	$modified = (preg_match('| \* @modified:(.*)$|mi',$str,$arr)) ? trim($arr[1]) : "-" ;
	$author = (preg_match('| \* @author:(.*)$|mi',$str,$arr)) ? trim($arr[1]) : "-" ;
	$author_email = (preg_match('| \* @author_email:(.*)$|mi',$str,$arr)) ? trim($arr[1]) : "-" ;
	$author_url = (preg_match('| \* @author_url:(.*)$|mi',$str,$arr)) ? trim($arr[1]) : "-" ;
	$actions = (preg_match('| \* @actions:(.*)$|mi',$str,$arr)) ? trim($arr[1]) : "-" ;
	$filemtime = filemtime($file);

	return array( 
				 'module' => $module, 
				 'name' => $name, 
				 'description' => $description, 
				 'version' => $version, 
				 'created' => $created, 
				 'modified' => $modified, 
				 'author' => $author, 
				 'author_email' => $author_email, 
				 'author_url' => $author_url, 
				 'actions' => $actions, 
				 'filemtime' => $filemtime );
}

//return an array witdh the modules info
function eko_get_modules_info()
{
	$ret = array();
	$tmpdir = EKO_PLUGIN_DIR . "mod/";
	if (is_dir($tmpdir))
	{
		$i=0;
		$tmpdirhandler = opendir($tmpdir);
		while($diritem = readdir($tmpdirhandler))
		{
			if (is_file("$tmpdir$diritem")&&(strpos($diritem,"mod.")!==false)&&(strpos($diritem,"mod.")==0))
			{
				//include_once("$tmpdir$diritem");
				//$ret[$i]["filepath"] = $tmpdir . $diritem;
				$ret[$i] = eko_get_moduledata($tmpdir . $diritem);
				$i++;
			};
		}
		closedir($tmpdirhandler);
	};
	return $ret;
};

function eko_style_tag()
{
	echo "\n\n<style type=\"text/css\">\n";
	echo "/* eko_style_tag */\n\n";
	do_action("eko_css");
	echo "\n\n</style>\n\n";
}

function eko_script_tag()
{
	echo "\n\n<script language=\"javascript\">\n";
	echo "/* eko_script_tag */\n\n";
	do_action("eko_js");
	echo "\n\n</script>\n\n";
};

//return true if the module was activated by admin user.
function eko_is_module_activated($module)
{
	$active_mods = get_option("eko_active_modules");
	$active_mods_arr = explode(",",$active_mods);
	for($i=0;$i<count($active_mods_arr);$i++)
	{
		if($active_mods_arr[$i]==$module) return true;
	}
	
	return false;
}

//returns an action permalink
function eko_get_permalink($action,$query_string="")
{
	global $wpdb;
    $page = $wpdb->get_row("SELECT * FROM `".$wpdb->posts."` WHERE `post_content` LIKE '%[".$action."]%'  AND `post_type` NOT IN('revision') LIMIT 1",ARRAY_A);
	//print_r($page);
	if($page == null)
	{
		$tmp = explode("_",$action,3);
		$eko_prefix = $tmp[0];
		$module = $tmp[1];
		if($eko_prefix=="eko")
		{
		    $page = $wpdb->get_row("SELECT * FROM `".$wpdb->posts."` WHERE `post_content` LIKE '%[eko_".$module."]%'  AND `post_type` NOT IN('revision') LIMIT 1",ARRAY_A);
			if($page == null)
			{
				return "#1";
			}
			else
			{
				$permalink = get_permalink($page["ID"]);
				$questionmark = (strchr($permalink,"?")) ? "" : "?";
				$permalink .= $questionmark . querystr("&page_id=&".$query_string);
				//$permalink .= $questionmark . querystr("&page_id=&eko_action=$action&".$query_string);
				//$permalink .= $questionmark . querystr($query_string);
				return $permalink;
			};
		}
		else
		{
			return "#2";
		};
	}
	else
	{
		$permalink = get_permalink($page["ID"]);
		$questionmark = (strchr($permalink,"?")) ? "" : "?";
		$permalink .= $questionmark . querystr("&page_id=&".$query_string);
		//$permalink .= $questionmark . querystr($query_string);
		return $permalink;
	}
};

//get the page id associated with an action. if theres no one, return ZERO.
function eko_get_page_id($action)
{
	global $wpdb;
    $page = $wpdb->get_row("SELECT * FROM `".$wpdb->posts."` WHERE `post_content` LIKE '%[".$action."]%'  AND `post_type` NOT IN('revision') LIMIT 1",ARRAY_A);
	if($page==null)
	{
		return 0;
	}
	else
	{
		return $page["ID"];
	};
	
	/*
	$sql = "SELECT page_id FROM ".EKO_DB_PREFIX."eko_actions_x_pages WHERE action_name = '$action'";
	if($rs=mysql_query($sql))
	{
		if(mysql_num_rows($rs)==0)
		{
			return 0;
		}
		else
		{
			$arr = mysql_fetch_array($rs);
			return $arr["page_id"];
		}
	}
	else
	{
		return 0;
	}
	*/
}


//get the page id associated with an action. if theres no one, return ZERO.
function eko_get_page_url($action,$args="")
{
	global $wpdb;
    $page = $wpdb->get_row("SELECT * FROM `".$wpdb->posts."` WHERE `post_content` LIKE '%[".$action."]%'  AND `post_type` NOT IN('revision') LIMIT 1",ARRAY_A);
	//print_r($page);
	if($page == null)
	{
		$ret = sprintf(__('There is no page associated with %s','eko'),strtoupper($action));
		return "javascript:alert('$ret');";
	}
	else
	{
		$permalink = get_permalink($page["ID"]);
		$questionmark = (strchr($permalink,"?")) ? "&" : "?";
		return $permalink.$questionmark.$args;
	};
};

//returns an array with the active modules actions
function eko_get_actions()
{
	$ret = array();
	$modules = eko_get_modules_info();
	$count = 0;
	for($i=0;$i<count($modules);$i++)
	{
		$actions = explode(",",$modules[$i]["actions"]);
		for($ii=0;$ii<count($actions);$ii++)
		{
			$ret[$count] = trim($actions[$ii]);
			$count++;
		};
	};
	return $ret;
};

//echo a select box with all the active modules actions
function eko_dropdown_actions($name="eko_actions",$selected="")
{
	?>
    <select name="<?=$name;?>">
    <?
	$action = eko_get_actions();
	sort($action);
	for($i=0;$i<count($action);$i++)
	{
		$selected_str = ($selected==$action[$i]) ? "selected=\"selected\"" : "" ;
		?>
		<option value="<?=$action[$i]?>" <?=$selected_str;?>><?=$action[$i]?></option>
		<?
	};
	?>
    </select>
    <?
}

//a dropdown menu with the last blog posts
function eko_dropdown_posts($num=10,$selected=0)
{
	$pl = wp_get_recent_posts($num);
	//echo count($pl);
	?>
    <select name="post_id">
    	<option value="0"><?php _e('None','eko'); ?></option>
    <?
	foreach ( $pl as $entry)
	{
		$sel = ($entry['ID']==$selected) ? "selected=\"selected\"" : "" ;
		?>
        <option value="<?=$entry['ID'];?>" <?=$sel;?> ><?=$entry['post_title'];?></option>
        <?
	};
	?>
    </select>
    <?
}

//adds a key in a querystring
function eko_add_querystring_var($url, $key, $value)
{
	$url = preg_replace('/(.*)(\?|&)' . $key . '=[^&]+?(&)(.*)/i', '$1$2$4', $url . '&');
	$url = substr($url, 0, -1);
	if (strpos($url, '?') === false)
	{
		return ($url . '?' . $key . '=' . $value);
	}
	else
	{
		return ($url . '&' . $key . '=' . $value);
	}
};

//remove a key in a querystring
function eko_remove_querystring_var($url, $key)
{
	$url = preg_replace('/(.*)(\?|&)' . $key . '=[^&]+?(&)(.*)/i', '$1$2$4', $url . '&');
	$url = substr($url, 0, -1);
	return ($url);
}

//replace a key in a querystring
function eko_replace_querystring_var($url, $key, $value)
{
	$url = eko_remove_querystring_var($url,$key);
	$url = eko_add_querystring_var($url,$key,$value);
	return $url;
}

//print a warning to user to update the database
function eko_db_warning()
{
	_warning(__('Please update the database!','eko'),__('The database is outdated. Please contact the site administrator.','eko'),"./","OK");
};

//returns true if the logged user has access to the resource defined in the database
function getaccess($id)
{
	//if wp user is logged in..
	if(is_user_logged_in())
	{
		$user = wp_get_current_user();

		$sql = "SELECT id_permission FROM ".EKO_DB_PREFIX."eko_usergroups_x_permissions WHERE id_permission = $id AND id_usergroup IN (SELECT id_usergroup FROM ".EKO_DB_PREFIX."eko_usergroups_x_wpusers WHERE id_wpuser = ".$user->id.")";
		if ($rs_ = mysql_query($sql))
		{
			//if the resource is associated witdh one of the user groups, then return true.
			return (mysql_num_rows($rs_)!=0);
		}
		else
		{
			//echo mysql_error();
			return false;
		};
	}
	//if wp user is not logged in, so we couldn't know if he has access
	else
	{
		return false;
	};
};

//draw an error message
function _error($title='',$message='')
{
	$title = ($title=="") ? __('There was an error processing this page:','eko') : $title ;
	$message = ($message=="") ?  '<li>' . __("Unspecified error.",'eko') . '</li>' : $message ;
	?>
	<div class="eko_error"><p><b><?php echo $title ?></b></p><ul><?php echo utf8_encode($message);?></ul><br /></div>
	<?php
};

//draw an info message
function _info($title = "",$message = "",$button="",$button_caption="OK")
{
	?>
	<div class="eko_info"><p><b><?php echo $title ?></b></p><ul><?php echo utf8_encode($message);?></ul><div style="text-align:right;"><button onclick="document.location='<?php echo $button; ?>'"> <?php echo $button_caption ?></button></div></div>
	<?php
};

//draw an warning message
function _warning($title = "",$message = "",$button="",$button_caption="OK")
{
	?>
	<div class="eko_warning"><p><b><?php echo $title ?></b></p><ul><?php echo utf8_encode($message);?></ul><div style="text-align:right;"><? if($button!="") { ?><button onclick="document.location='<?php echo $button; ?>'"> <?php echo $button_caption ?></button><? } ?></div></div>
	<?php
};

function _noaccess($title = "",$message = "",$button="",$button_caption="OK")
{
	$title = ($title=="") ? __('Access denied.','eko') : $title ;
	$message = ($message=="") ?  '<li>' . __("You do not have access to this feature. Please contact your system administrator for more information.",'eko') . '</li>' : $message ;
	?>
	<div class="eko_warning"><p><b><?php echo $title ?></b></p><ul><?php echo $message;?></ul><div style="text-align:right;"><? if($button!="") { ?><button onclick="document.location='<?php echo $button; ?>'"> <?php echo $button_caption ?></button><? } ?></div></div>
	<?php
}

function linebreakToTag($str)
/**
 * replaces a line break with the <br> tag. I modified the display mode for
    personalization.
 * @creation: 09-mai-2008
 * @modified: 09-mai-2008
 * @author: Igo Santos <web@igosantos.com>
 * @more: www.wdabliu.com.br
 **/
{
	$order   = array("\r\n", "\n", "\r");
	$replace = '<br />';
	$newstr = str_replace($order, $replace, $str);
	return $newstr;
}

function htmlencode($string)
{
	// by Filippo Levizzani, arranged on htmlencode function
	//found inside phorum.org code
	$okString="|a|b|c|d|e|f|g|h|i|j|k|l|m|n|o|p|q|r|s|t|u|v|w|x|y|z|A|B|C|D|E|F|G|H|I|J|K|L|M|N|O|P|Q|R|T|U|V|W|X|Y|Z|1|2|3|4|5|6|7|8|9|0|'|!|?|(|)|/|=|.|,|-|;| |";
	$ret_string="";
	$len=strlen($string);
	for($x=0;$x<$len;$x++)
	{
		if ( strstr( $okString, "|".$string[$x]."|" ) )
		{
			$ret_string .= $string[$x];
		}
		else
		{
			$ord=ord($string[$x]);
			$ret_string .= "&#$ord;";
		}
	}
	return $ret_string;
}

//draw next/prev navigation
function prevnext($start = 0, $size = 10, $total = 4)
{
	$str_prev = "";
	$str_next = "";
	
	if(isset($_GET["start"]))
	{
		//parse querystring
		while ($ar = (each($_GET)))
		{
			$str_prev .= ($str_prev=="") ? ( ($ar[0]=="start") ? "start=" . ((($start - $size) <= 0) ? 0 : ($start - $size)) : ($ar[0] . "=" . $ar[1]) ) : "&".(($ar[0]=="start") ? "start=" . ((($start - $size) <= 0) ? 0 : ($start - $size)) : ($ar[0] . "=" . $ar[1]))  ;
			$str_next .= ($str_next=="") ? ( ($ar[0]=="start") ? "start=" . ( ($total!=0) ? ( ($start + $size >= $total) ? $total : $start + $size ) : ($start + $size) ) : ($ar[0] . "=" . $ar[1]) ) : "&".(($ar[0]=="start") ? "start=" . ( ($total!=0) ? ( ($start + $size >= $total) ? $total : $start + $size ) : ($start + $size) ) : ($ar[0] . "=" . $ar[1]))  ;
		};
	}
	else
	{
		$str_prev = $_SERVER['QUERY_STRING'] . "&start=" . ((($start - $size) <= 0) ? 0 : ($start - $size));
		$str_next = $_SERVER['QUERY_STRING'] . "&start=" . ( ($total!=0) ? ( ($start + $size >= $total) ? $total : $start + $size ) : ($start + $size) );
	};
	
	?>
    <a href="./?<?=$str_prev;?>"><img src="img/_layout/bt_anterior.jpg" width="65" height="16" /></a>
    <a href="./?<?=$str_next;?>"><img src="img/_layout/bt_proximo.jpg" width="65" height="16" /></a>
	<?
};

// parse the querystring args
function querystr($args)
{
	$res  = "";
	if($args == "") return $res;
	$args_arr = split("&",$args);
	//print_r($args_arr);
	$get_arr = $_GET;
	while ($ar = (each($get_arr)))
	{
		$flag = false;
		$new_value = "";
		for ($i=0;$i<count($args_arr);$i++)
		{
			$item = split("=",$args_arr[$i]);
			if(($ar[0] == $item[0]))
			{
				$flag = true;
				$new_value = $item[1];
			};
			
		};
		
		if($flag)
		{
			if($new_value!="") $res .= "&".$ar[0]."=".$new_value;
		}
		else
		{
			$res .= "&".$ar[0]."=".$ar[1];
		};
	};

	for ($i=0;$i<count($args_arr);$i++)
	{
		$item = split("=",$args_arr[$i]);
		if(!isset($_GET[$item[0]])) $res .= "&".$item[0] . "=" . $item[1];
	};
	
	return $res;
};

//link to the gravatar image
function gravatar_url($email,$size=100,$default="")
{
	$grav_url = "http://www.gravatar.com/avatar.php?".
	"gravatar_id=".md5( strtolower($email) ).
	"&default=".urlencode($default).
	"&size=".$size; 
	return $grav_url;
};


?>