<?
/**
 * EKO WP PLUGIN MODULE HEADER
 *
 * @module: contact
 * @name: Contact
 * @description: Adds a page with a contact form, with a message log register.	
 * @version: 0.3
 * @created: 2009-09-01
 * @modified: 2010-01-26
 * @author: Igo Santos
 * @author_email: web@igosantos.com
 * @author_url: www.igosantos.com
 * @actions: eko_contact, eko_contact_config
 * @required_modules: core
 *
 *    Copyright (C) 2009  Igo Santos <web@igosantos.com>
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 **/

//update the module database tables
function eko_contact_db_update()
{
	$sql[0] = "CREATE TABLE IF NOT EXISTS ".EKO_DB_PREFIX."eko_contact_config (`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY)";
	$sql[1] = "ALTER TABLE ".EKO_DB_PREFIX."eko_contact_config ADD COLUMN `nome` VARCHAR( 255 ) NOT NULL;";
	$sql[2] = "ALTER TABLE ".EKO_DB_PREFIX."eko_contact_config ADD COLUMN `valor` VARCHAR( 255 ) NOT NULL;";
	
	$sql[3] = "INSERT INTO `".EKO_DB_PREFIX."eko_contact_config` (`id`, `nome`, `valor`) VALUES (1, 'email_to', 'web@igosantos.com');";
	$sql[4] = "INSERT INTO `".EKO_DB_PREFIX."eko_contact_config` (`id`, `nome`, `valor`) VALUES (2, 'nome_to', 'Igo Santos');";
	$sql[5] = "INSERT INTO `".EKO_DB_PREFIX."eko_contact_config` (`id`, `nome`, `valor`) VALUES (3, 'subject', 'Contato de ".get_option("blogname") . " [" . get_option("siteurl")."]');";
	
	$sql[6] = "CREATE TABLE IF NOT EXISTS ".EKO_DB_PREFIX."eko_contact_msgs (`id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY)";
	$sql[7] = "ALTER TABLE ".EKO_DB_PREFIX."eko_contact_msgs ADD COLUMN `nome` VARCHAR( 255 ) NOT NULL;";
	$sql[8] = "ALTER TABLE ".EKO_DB_PREFIX."eko_contact_msgs ADD COLUMN `email` VARCHAR( 255 ) NOT NULL;";
	$sql[9] = "ALTER TABLE ".EKO_DB_PREFIX."eko_contact_msgs ADD COLUMN `msg` TEXT NOT NULL;";
	$sql[10] = "ALTER TABLE ".EKO_DB_PREFIX."eko_contact_msgs ADD COLUMN `datahora` DATETIME NOT NULL;";
	
		
	$ret = array();

	$erros = "";
	
	for($i=0;$i<count($sql);$i++)
	{
		if (!mysql_query($sql[$i])) $erros .="<li>[SQL$i]:".mysql_error()."</li>";
	};
	
	if($erros=="")
	{
		$ret[0] = true;
		$ret[1] = "";
	}
	else
	{
		$ret[0] = false;
		$ret[1] = $erros;
	};

	return $ret;
};

//drop previously created database tables
function eko_contact_db_drop()
{
	$sql[0] = "DROP TABLE IF EXISTS ".EKO_DB_PREFIX."eko_contact_config;";
	$sql[1] = "DROP TABLE IF EXISTS ".EKO_DB_PREFIX."eko_contact_msgs;";
	
	$ret = array();

	$erros = "";
	
	for($i=0;$i<count($sql);$i++)
	{
		if (!mysql_query($sql[$i])) $erros .="<li>[SQL$i]:".mysql_error()."</li>";
	};
	
	if($erros=="")
	{
		$ret[0] = true;
		$ret[1] = "";
	}
	else
	{
		$ret[0] = false;
		$ret[1] = $erros;
	};

	return $ret;
};

//check if the required database tables are installed.
function eko_contact_db_check()
{
	$sql[0] = "SELECT id,nome,valor FROM ".EKO_DB_PREFIX."eko_contact_config LIMIT 1;";
	$sql[1] = "SELECT id,nome,email,msg,datahora FROM ".EKO_DB_PREFIX."eko_contact_msgs LIMIT 1;";
	
	for ($i=0;$i<count($sql);$i++) if (!mysql_query($sql[$i])) return false;
	
	$sql_check_config[0] = "SELECT id FROM ".EKO_DB_PREFIX."eko_contact_config WHERE id = 1 AND nome = 'email_to'";
	$sql_check_config[1] = "SELECT id FROM ".EKO_DB_PREFIX."eko_contact_config WHERE id = 2 AND nome = 'nome_to'";
	$sql_check_config[2] = "SELECT id FROM ".EKO_DB_PREFIX."eko_contact_config WHERE id = 3 AND nome = 'subject'";
	
	for ($i=0;$i<count($sql_check_config);$i++)
	{
		if ($rs = mysql_query($sql_check_config[$i]))
		{
			if(mysql_num_rows($rs)==0) return false;
		}
		else
		{
			return false;
		};
		
	};
	
	return true;
};

//the module css
function eko_contact_css()
{
	?>
    /* eko_contact_css */
    <?
};

//get the module settings in the config table
function eko_contact_getconfig($name)
{
	return eko_core_getconfig($name,"contact");
}

//the config form
function eko_contact_config()
{
	//check if the databases are installed. if not, exit function.
	if(!eko_contact_db_check())
	{
		eko_db_warning();
		return;
	}
	?>
	<fieldset class="eko_fieldset">
		<legend><? _e('Configuration form:','eko'); ?></legend>
		<?
		eko_core_configform("contact",15,eko_get_page_url("eko_contact"));
		?>
	</fieldset>
	
	<h3><? _e('Instructions:','eko'); ?></h3>			
	<p><? _e('To update this module settings, please change the form fields above and click in &quot;Save&quot;.','eko'); ?></p>
	<p><? _e('Check the description of the form fields:','eko'); ?></p>
	
	<ul>
		<li>
			<b>mail_to:</b>
			<ul>
				<li><? _e('E-mail address to receive the messages.','eko'); ?></li>
			</ul>
		</li>
		<li>
			<b>nome_to:</b>
			<ul>
				<li><? _e('Name of person or company that will receive the messages.','eko'); ?></li>
			</ul>
			
		</li>
			
		<li>
			<b>subject:</b>
			<ul>
				<li><? _e('What will be shown in the &quot;Subject&quot; field of received messages.','eko');?></li>
			</ul>
		</li>
	</ul>
	<?
};

//draw the contact form
function eko_contact_sendform()
{
	//check if the databases are installed. if not, exit function.
	if(!eko_contact_db_check())
	{
		eko_db_warning();
		return;
	}
		
	if($_SERVER['REQUEST_METHOD']=="POST")
	{
		$email_to = eko_contact_getconfig("email_to");
		$nome_to = eko_contact_getconfig("nome_to");
		$subject = eko_contact_getconfig("subject");
		
		$html = $_REQUEST["msg"];
		$headers = "MIME-Version: 1.0\r\n"; 
		//$headers .= "Content-type: text/html; charset=iso-8859-1\n"; 
		$headers .= "Content-type: text/html; charset=utf-8\r\n"; 
		$headers .= "From: $nome_to <$email_to>\r\n";
		$headers .= "Reply-To: ".$_REQUEST["nome"]." <".$_REQUEST["email"].">\r\n";
		$headers .= "Return-Path: $nome_to <$email_to>\r\n"; 
		
		$sql = "INSERT INTO ".EKO_DB_PREFIX."eko_contact_msgs VALUES (NULL,'".$_REQUEST["nome"]."','".$_REQUEST["email"]."','$html',CURRENT_TIMESTAMP)";
		mysql_query($sql);
		
		if(mail($email_to,$subject,$html,$headers))
		{
			_info(__('Success!','eko'),__('Your message was successfully sent, thank you!','eko'),$_SERVER['HTTP_REFERER']);
		}
		else
		{
			_warning(__('Error','eko'),"<li>". __('There was an error trying to send your message. Please try again.','eko') ."</li>",$_SERVER['HTTP_REFERER']);
		};
	}
	else
	{
		?>
		<form method="post">
			<table class="eko_form-table">
				<tr>
					<th><? _e('Name:','eko'); ?></th>
					<td><input type="text" name="nome" /></td>
				</tr>
				<tr>
					<th><? _e('Email:','eko'); ?></th>
					<td><input type="text" name="email" /></td>
				</tr>
				<tr>
					<th><? _e('Message:','eko'); ?></th>
					<td><textarea name="msg"></textarea></td>
				</tr>
				<tr>
					<th>&nbsp;</th>
					<td><input type="submit" value="<? _e('Send','eko'); ?>" style="width:70px;" /></td>
				</tr>
				<? if(getaccess(15)) { ?>
				<tr>
					<th>&nbsp;</th>
					<td><a href="<?=eko_get_page_url("eko_contact","eko_action=1");?>"><? _e('Configure this module','eko');?></a></td>
				</tr>
				<? } ?>
				<? if(getaccess(24)) { ?>
				<tr>
					<th>&nbsp;</th>
					<td><a href="<?=eko_get_page_url("eko_contact","eko_action=2");?>"><? _e('Recent messages list','eko'); ?></a></td>
				</tr>
				<? } ?>
			</table>
		</form>
		<?
	};
};

//the list of last messages
function eko_contact_listmessages()
{
	//check if the databases are installed. if not, exit function.
	if(!eko_contact_db_check())
	{
		eko_db_warning();
		return;
	}
	
	if(getaccess(24))
	{
		if ($_REQUEST["eko_contact_msg_id"])
		{
			$sql ="SELECT * FROM ".EKO_DB_PREFIX."eko_contact_msgs WHERE id = ".$_REQUEST["eko_contact_msg_id"]."";
			if($rs = mysql_query($sql))
			{
				$arr = mysql_fetch_array($rs);
				?>
				<fieldset class="eko_fieldset">
					<legend>
						<? printf(__('%1$s &lt;%2$s&gt; on %3$s','eko'),$arr['nome'],$arr['email'],mysql2date(__('m/d/Y','eko'),$arr["datahora"])); ?>
                    </legend>
					<div><?=linebreakToTag($arr["msg"]);?></div>
				</fieldset>
				<?
			}
			else
			{
				_error(__('Error:','eko'),"<li>".mysql_error()."</li>");
			};
			
		}
		?>
		<table class="eko_table">
        	<thead>
			<tr>
				<th><? _e('ID','eko'); ?></th>
				<th><? _e('Date','eko'); ?></th>
				<th><? _e('Name','eko'); ?></th>
				<th><? _e('Email','eko'); ?></th>
			</tr>
            </thead>
            <tbody>
			<?
			$sql = "SELECT * FROM ".EKO_DB_PREFIX."eko_contact_msgs ORDER BY id DESC LIMIT 12";
			if ($rs = mysql_query($sql))
			{
				if(mysql_num_rows($rs)==0)
				{
					?>
					<tr>
						<td colspan="4"><? _e('No messages yet.','eko'); ?></td>
					</tr>
					<?
				}
				else
				{
					while($arr=mysql_fetch_array($rs))
					{
						?>
						<tr>
                        	<td><a href="<?=eko_get_page_url("eko_contact","eko_action=2&eko_contact_msg_id=".$arr["id"]);?>"><?=$arr["id"];?></a></td>
							<th><a href="<?=eko_get_page_url("eko_contact","eko_action=2&eko_contact_msg_id=".$arr["id"]);?>"><?=mysql2date(__('m/d/Y h:i a','eko'),$arr["datahora"]);?></a></th>
							<th><a href="<?=eko_get_page_url("eko_contact","eko_action=2&eko_contact_msg_id=".$arr["id"]);?>"><?=$arr["nome"];?></a></th>
							<th><a href="<?=eko_get_page_url("eko_contact","eko_action=2&eko_contact_msg_id=".$arr["id"]);?>"><?=$arr["email"];?></a></th>
						</tr>
						<?
					};
				}
			}
			else
			{
					?>
					<tr>
						<td colspan="4"><? _error(__('Error:','eko'),"<li>".mysql_error()."</li>");?></td>
					</tr>
					<?
			}
			?>
            </tbody>
		</table>
        <p><button onclick="document.location='<?=eko_get_page_url("eko_contact");?>';"><? _e('Back','eko'); ?></button></p>
		<?
	}
	else
	{
		_noaccess();
	}
};

//main action
function eko_contact()
{
	switch($_REQUEST["eko_action"])
	{
		case 2:
			eko_contact_listmessages();
			break;
		case 1:
			eko_contact_config();
			break;
		default:
			eko_contact_sendform();
			break;
	};
};

add_action("eko_css","eko_contact_css");
?>