<?
/**
 * EKO WP PLUGIN MODULE HEADER
 *
 * @module: guestbook
 * @name: Guestbook
 * @description: Adds a scrapbook to the site.
 * @version: 0.6
 * @created: 2009-04-26
 * @modified: 2010-01-26
 * @author: Igo Santos
 * @author_email: web@igosantos.com
 * @author_url: www.igosantos.com
 * @actions: eko_guestbook, eko_guestbook_config
 * @required_modules: core
 *
 *    Copyright (C) 2009  Igo Santos <web@igosantos.com>
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 **/

//update the module database tables
function eko_guestbook_db_update()
{
	$sql[0] = "CREATE TABLE IF NOT EXISTS ".EKO_DB_PREFIX."eko_guestbook_config(`id` int(11) NOT NULL auto_increment PRIMARY KEY);";
	$sql[1] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook_config ADD COLUMN `nome` VARCHAR( 255 ) NOT NULL;";
	$sql[2] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook_config ADD COLUMN `valor` VARCHAR( 255 ) NOT NULL;";
	
	$sql[3] = "INSERT INTO `".EKO_DB_PREFIX."eko_guestbook_config` (`id`, `nome`, `valor`) VALUES (1, 'msgs_per_page', '15')";
	
	$sql[4] = "CREATE TABLE IF NOT EXISTS ".EKO_DB_PREFIX."eko_guestbook (`id` int(11) NOT NULL auto_increment PRIMARY KEY);";
	$sql[5] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook ADD COLUMN `datahora` DATETIME NOT NULL;";
	$sql[6] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook ADD COLUMN `nome` VARCHAR( 255 ) NOT NULL;";
	$sql[7] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook ADD COLUMN `email` VARCHAR( 255 ) NOT NULL;";
	$sql[8] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook ADD COLUMN `url` VARCHAR( 255 ) NOT NULL;";
	$sql[9] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook ADD COLUMN `msg` TEXT NOT NULL;";
	$sql[10] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook ADD COLUMN `user_id` INT NOT NULL;";
	$sql[11] = "ALTER TABLE ".EKO_DB_PREFIX."eko_guestbook ADD COLUMN `status` INT NOT NULL;";
	
	$sql[12] = "INSERT INTO `".EKO_DB_PREFIX."eko_guestbook_config` (`id`, `nome`, `valor`) VALUES (2, 'moderate', '0')";
	$sql[13] = "INSERT INTO `".EKO_DB_PREFIX."eko_guestbook_config` (`id`, `nome`, `valor`) VALUES (3, 'send_email_to', 'web@igosantos.com')";
	$sql[14] = "INSERT INTO `".EKO_DB_PREFIX."eko_guestbook_config` (`id`, `nome`, `valor`) VALUES (4, 'email_subject', '".sprintf(__('[eko_guestbook] New guestbook message from %1$s - %2$s','eko'),get_option('blogname'),get_option('siteurl'))."')";
	
	$ret = array();
	
	$erros = "";
	
	for($i=0;$i<count($sql);$i++)
	{
		if (!mysql_query($sql[$i])) $erros .="<li>[SQL$i]:".mysql_error()."</li>";
	};
	
	if($erros=="")
	{
		$ret[0] = true;
		$ret[1] = "";
	}
	else
	{
		$ret[0] = false;
		$ret[1] = $erros;
	};
	
	return $ret;
	
};

//drop previously created database tables
function eko_guestbook_db_drop()
{
	$sql[0] = "DROP TABLE IF EXISTS ".EKO_DB_PREFIX."eko_guestbook_config;";
	$sql[1] = "DROP TABLE IF EXISTS ".EKO_DB_PREFIX."eko_guestbook;";
	
	$ret = array();

	$erros = "";
	
	for($i=0;$i<count($sql);$i++)
	{
		if (!mysql_query($sql[$i])) $erros .="<li>[SQL$i]:".mysql_error()."</li>";
	};
	
	if($erros=="")
	{
		$ret[0] = true;
		$ret[1] = "";
	}
	else
	{
		$ret[0] = false;
		$ret[1] = $erros;
	};

	return $ret;
};

//check if the required database tables are installed.
function eko_guestbook_db_check()
{
	$sql[0] = "SELECT id,nome,valor FROM ".EKO_DB_PREFIX."eko_guestbook_config LIMIT 1;";
	$sql[1] = "SELECT id,datahora,nome,email,url,msg,user_id,status FROM ".EKO_DB_PREFIX."eko_guestbook LIMIT 1;";
	
	for ($i=0;$i<count($sql);$i++) if (!mysql_query($sql[$i])) return false;
	
	$sql_check_config[0] = "SELECT id FROM ".EKO_DB_PREFIX."eko_guestbook_config WHERE id = 2 AND nome = 'moderate'";
	$sql_check_config[1] = "SELECT id FROM ".EKO_DB_PREFIX."eko_guestbook_config WHERE id = 3 AND nome = 'send_email_to'";
	$sql_check_config[2] = "SELECT id FROM ".EKO_DB_PREFIX."eko_guestbook_config WHERE id = 4 AND nome = 'email_subject'";
	
	for ($i=0;$i<count($sql_check_config);$i++)
	{
		if ($rs = mysql_query($sql_check_config[$i]))
		{
			if(mysql_num_rows($rs)==0) return false;
		}
		else
		{
			return false;
		};
		
	};
	
	return true;
};

//the module css
function eko_guestbook_css()
{
	?>
    /* eko_guestbook_css <style-> */
	
	.eko_guestbook_textarea {
		width:100%;
	}
	
    .eko_guestbook_list li h3 {
    	margin:0px;
        padding:0px;
        border:1px solid;
    }
    /*
	.grey {
	}
    
	.eko_guestbook_content {
		position:relative;
		padding:20px;
	}
	
	.eko_guestbook_item {
		position:relative;
		clear:both;
		padding:20px 0px 20px 0px;
	}

	.eko_guestbook_item_grey {
		background:#f7f7f7;
		border:1px #ddd solid;
		position:relative;
		clear:both;
		padding:20px 0px 20px 0px;
	}

	.eko_guestbook_item_msg {
		padding:10px 0px 10px 0px;
		position:relative;
		clear:both;
	}
	
	.eko_guestbook_item_img {
		padding: 0px 0px 0px 10px;
		position:relative;
		float:left;
		width:110px;
	}
	
	.eko_guestbook_item_title {
		position:relative;
	}

	.eko_guestbook_item_title h2 {
		border-bottom:#ccc 1px dotted;
		font-size:18px;
		font-weight:bold;
	}
	
	.eko_guestbook_item_title h2 a {
		font-size:18px;
		font-weight:bold;
	}
	
	.eko_guestbook_item_title span, .eko_guestbook_item_title span a  {
		font-size:90%;
		font-weight:bold;
	}
    */
    <?
};

//the config form
function eko_guestbook_config()
{
	//check if the databases are installed. if not, exit function.
	if(!eko_guestbook_db_check())
	{
		eko_db_warning();
		return;
	}
	?>
	<fieldset class="eko_fieldset">
		<legend><? _e('Configuration form','eko');?></legend>
		<?
		//check the correct permission!
		eko_core_configform("guestbook",16,eko_get_page_url("eko_guestbook"));
		?>
	</fieldset>
	
	<h3><? _e('Instructions:','eko'); ?></h3>			
	<p><? _e('To update this module settings, please change the form fields above and click in &quot;Save&quot;.','eko'); ?></p>
	<p><? _e('Check the description of the form fields:','eko'); ?></p>
	
	<ul>
		<li>
			<b>msgs_per_page:</b>
			<ul>
				<li><? _e('Number of messages displayed per page.','eko');?></li>
			</ul>
		</li>
		<li>
			<b>moderate:</b>
			<ul>
				<li><? _e('If set to 1, a new message need to be approved by a moderator before appearing on the list.','eko');?></li>
			</ul>
		</li>
		<li>
			<b>send_email_to:</b>
			<ul>
				<li><? _e('When a new message is posted, send an email to this address.','eko'); ?></li>
			</ul>
		</li>
		<li>
			<b>email_subject:</b>
			<ul>
				<li><? _e('The subject of the email sent when a new message is posted.','eko'); ?></li>
			</ul>
		</li>
	</ul>
	<?
};

//get the module settings
function eko_guestbook_getconfig($nome)
{
	return eko_core_getconfig($nome,"guestbook");
};

function eko_guestbook_list_status_change()
{
	$sql = "SELECT status FROM ".EKO_DB_PREFIX."eko_guestbook WHERE id = ".$_REQUEST["eko_gbk_status_change"];
	$rs = mysql_query($sql);
	$arr = mysql_fetch_array($rs);
	$status = ($arr["status"]) ? "0" : "1" ;
	$sql = "UPDATE ".EKO_DB_PREFIX."eko_guestbook SET status = $status  WHERE id = ".$_REQUEST["eko_gbk_status_change"];
	//echo $arr["status"] . "-->" . $status;
	if(!mysql_query($sql)) _warning("Erro:","<li>".mysql_error()."<li>");
	//mysql_query($sql);
	eko_guestbook_list();
};

//action that outputs some information about this module
function eko_guestbook_list()
{
	//check if the databases are installed. if not, exit function.
	if(!eko_guestbook_db_check())
	{
		eko_db_warning();
		return;
	}
		
	if (is_user_logged_in())
	{
		$user = wp_get_current_user();
		
		?>
		<form method="post" action="<?=eko_get_page_url("eko_guestbook","eko_action=2");?>">
			<table class="eko_form-table">
				<tr>
					<th><? _e('Name:','eko'); ?></th>
					<td><?=$user->user_nicename;?></td>
				</tr>
				<tr>
					<th><? _e('Email:','eko'); ?></th>
					<td><?=$user->user_email;?></td>
				</tr>
				<tr>
					<th><? _e('Website:','eko'); ?></th>
					<td><?=$user->user_url;?></td>
				</tr>
				<tr>
					<th><? _e('Message:','eko'); ?></th>
					<td><textarea name="msg"></textarea></td>
				</tr>
				<tr>
					<th>&nbsp;</th>
					<td><input class="eko_input_submit" type="submit" value="<? _e('Send!','eko'); ?>" /></td>
				</tr>
				<? if(getaccess(16)) { ?>
				<tr>
					<th>&nbsp;</th>
					<td><a href="<?=eko_add_querystring_var(eko_get_page_url("eko_guestbook"),"eko_action",1);?>"><? _e('Configure this module','eko'); ?></a></td>
				</tr>
				<? } ?>
			</table>
		</form>
		<?
	}
	else
	{
		?>
		<form method="post" action="<?=eko_get_page_url("eko_guestbook","eko_action=2");?>">
			<table class="eko_form-table">
				<tr>
					<th><? _e('Name:','eko'); ?></th>
					<td><input type="text" name="nome" /></td>
				</tr>
				<tr>
					<th><? _e('Email:','eko'); ?></th>
					<td><input type="text" name="email" /></td>
				</tr>
				<tr>
					<th><? _e('Website:','eko'); ?></th>
					<td><input type="text" name="url" /></td>
				</tr>
				<tr>
					<th><? _e('Message:','eko'); ?></th>
					<td><textarea name="msg"></textarea></td>
				</tr>
				<tr>
					<th>&nbsp;</th>
					<td><input class="eko_input_submit" type="submit" value="<? _e('Send!','eko'); ?>" /></td>
				</tr>
				<? if(getaccess(16)) { ?>
				<tr>
					<th>&nbsp;</th>
					<td><a href="<?=eko_add_querystring_var(eko_get_page_url("eko_guestbook"),"eko_action",1);?>"><? _e('Configure this module','eko'); ?></a></td>
				</tr>
				<? } ?>
			</table>
		</form>
		<?
	};
	
	if(getaccess(17))
	{
		$sql = "SELECT * FROM ".EKO_DB_PREFIX."eko_guestbook ORDER BY id DESC LIMIT ".eko_guestbook_getconfig("msgs_per_page");
	}
	else
	{
		$sql = "SELECT * FROM ".EKO_DB_PREFIX."eko_guestbook WHERE status = 1 ORDER BY id DESC LIMIT ".eko_guestbook_getconfig("msgs_per_page");
	};
	
    if($rs=mysql_query($sql))
    {
        $i=0;
        while($arr=mysql_fetch_array($rs))
        {
            ?>
            <br />
            <table class="eko_table">
            <thead>
            	<?
				$url = (($arr["url"]=="http://")||($arr["url"]=="")) ? "#" : $arr["url"] ;
				$name = $arr["nome"];
				$date = mysql2date(__('m/d/Y','eko'),$arr['datahora']);
				
                ?>
                <th><? printf(__('<a href="%1$s">%2$s</a> on %3$s:','eko'),$url,$name,$date); ?></th>
            </thead>
            <tbody>
                <th><?=linebreakToTag($arr["msg"]);?></th>
            </tbody>
            <? if(getaccess(17)) { ?>
            <tbody>
                <th>
                	<a href="<?=eko_get_page_url("eko_guestbook","eko_action=4&eko_list_id=".$arr["id"]);?>">[excluir]</a>
                    <!-- <a href="<?=eko_get_page_url("eko_guestbook");?>">[editar]</a> -->
                    <a href="<?=eko_get_page_url("eko_guestbook","eko_action=3&eko_gbk_status_change=".$arr["id"]);?>"><? if($arr["status"]==0) {?><b>[publicar]</b><? } else { ?>[despublicar]<? } ?></a>
                </th>
            </tbody>
            <? } ?>
            </table>
            <?
            $i++;
        };
    }
    else
    {
        _warning(__("Error:"),"<li>".mysql_query()."</li>");
    };
};

//action for guestbook message submit
function eko_guestbook_list_add()
{
	if (is_user_logged_in())
	{
		$user = wp_get_current_user();
		$id = $user->ID;
		$nome = $user->user_nicename;
		$email = $user->user_email;
		$url = $user->user_url;
		$msg = $_REQUEST["msg"];
		$status = (eko_guestbook_getconfig("moderate")=="1") ? 0 : 1 ;
		
		$erros = "";
		$sql = "INSERT INTO ". EKO_DB_PREFIX . "eko_guestbook VALUES (NULL,CURRENT_TIMESTAMP,'$nome','$email','$url','$msg','$id','$status')";
		//echo $sql;
		
		if ($msg=="")
		{
			$erros .= "<li>".__('The MESSAGE field is required.','eko')."</li>";
		};
		
		if ($erros=="")
		{
			if(mysql_query($sql))
			{
				if($status)
				{
					_info(__('Success!','eko'),__('Your message was successfully sent!','eko'),eko_get_page_url("eko_guestbook"));
				}
				else
				{
					//send email to admin
					$send_email_to = eko_guestbook_getconfig("send_email_to");
					$subject = eko_guestbook_getconfig("email_subject");
					$html = sprintf(__('<p>A new guestbook message has been added to your site:</p><ul><li><b>Name:</b> %1$s</li><li><b>Message:</b> %2$s</li></ul>','eko'),$nome,$msg);
					$headers = "MIME-Version: 1.0\r\n"; 
					$headers .= "Content-type: text/html; charset=utf-8\r\n"; 
					//$headers .= "Content-type: text/html; charset=iso-8859-1\n"; 
					//$headers .= "From: $nome_to <$email_to>\r\n";
					//$headers .= "Reply-To: ".$_REQUEST["nome"]." <".$_REQUEST["email"].">\r\n";
					//$headers .= "Return-Path: $nome_to <$email_to>\r\n"; 
					//echo $send_email_to;
					mail($send_email_to,$subject,$html,$headers);
					_info(__('Success!','eko'),__('Your message was sent successfully, but it still have to be approved by our moderators.','eko'),eko_get_page_url("eko_guestbook"));
				};
			}
			else
			{
				_warning(__('Unable to send the message due to the following error(s):','eko'),"<li>".mysql_error()."</li>",eko_get_page_url("eko_guestbook"),__('Back','eko'));
			};
		}
		else
		{
			_warning(__('Unable to send the message due to the following error(s)','eko'),$erros,eko_get_page_url("eko_guestbook"),__('Back','eko'));
		};
	}
	else
	{
		$id = 0;
		$nome = $_REQUEST["nome"];
		$email = $_REQUEST["email"];
		$url = $_REQUEST["url"];
		$msg = $_REQUEST["msg"];
		$status = (eko_guestbook_getconfig("moderate")=="1") ? 0 : 1 ;
		$erros = "";
		$sql = "INSERT INTO ". EKO_DB_PREFIX . "eko_guestbook VALUES (NULL,CURRENT_TIMESTAMP,'$nome','$email','$url','$msg','$id',$status)";
		
		if ($msg=="")
		{
			$erros .= "<li>".__('The MESSAGE field is required.','eko')."</li>";
		};
		
		if ($nome=="")
		{
			$erros .= "<li>".__('The NAME field is required.','eko')."</li>";
		};
		
		if ($email=="")
		{
			$erros .= "<li>".__('The EMAIL field is required.','eko')."</li>";
		};
		
		if ($erros=="")
		{
			if(mysql_query($sql))
			{
				if($status)
				{
					_info(__('Success!','eko'),__('Your message was successfully sent!','eko'),eko_get_page_url("eko_guestbook"));
				}
				else
				{
					//send email to admin
					$send_email_to = eko_guestbook_getconfig("send_email_to");
					$subject = eko_guestbook_getconfig("email_subject");
					$html = sprintf(__('<p>A new guestbook message has been added to your site:</p><ul><li><b>Name:</b> %1$s</li><li><b>Message:</b> %2$s</li></ul>','eko'),$nome,$msg);
					$headers = "MIME-Version: 1.0\r\n"; 
					$headers .= "Content-type: text/html; charset=utf-8\r\n"; 
					//$headers .= "Content-type: text/html; charset=iso-8859-1\n"; 
					//$headers .= "From: $nome_to <$email_to>\r\n";
					//$headers .= "Reply-To: ".$_REQUEST["nome"]." <".$_REQUEST["email"].">\r\n";
					//$headers .= "Return-Path: $nome_to <$email_to>\r\n"; 
					//echo $send_email_to;
					mail($send_email_to,$subject,$html,$headers);
					_info(__('Success!','eko'),__('Your message was sent successfully, but it still have to be approved by our moderators.','eko'),eko_get_page_url("eko_guestbook"));
				};
			}
			else
			{
				_warning(__('Unable to send the message due to the following error(s)','eko'),"<li>".mysql_error()."</li>",eko_get_page_url("eko_guestbook"),__('Back','eko'));
			};
		}
		else
		{
			_warning(__('Unable to send the message due to the following error(s)','eko'),$erros,eko_get_page_url("eko_guestbook"),__('Back','eko'));
		};
	};
};

function eko_guestbook_list_delete()
{
	//check if the databases are installed. if not, exit function.
	if(!eko_guestbook_db_check())
	{
		eko_db_warning();
		return;
	}
	
	//check user permission
	
	if(getaccess(16))
	{
		$sql ="DELETE FROM ".EKO_DB_PREFIX."eko_guestbook WHERE id = ".$_REQUEST["eko_list_id"];
		if(!mysql_query($sql)) _warning(__('Error:','eko'),"<li>".mysql_error()."</li>");
	}
	else
	{
		_noaccess();
	};
	
	eko_guestbook_list();
};

//main action
function eko_guestbook()
{
	switch($_REQUEST["eko_action"])
	{
		case 4:
			eko_guestbook_list_delete();
			break;
		case 3:
			eko_guestbook_list_status_change();
			break;
		case 2:
			eko_guestbook_list_add();
			break;
		case 1:
			eko_guestbook_config();
			break;
		default:
			eko_guestbook_list();
			break;
	};
};

//--WIDGET----
class eko_guestbook_widget_lastmessages extends WP_Widget
{
	function eko_guestbook_widget_lastmessages()
	{
		parent::WP_Widget(false, $name = 'Eko: Guestbook');
	}

	function widget($args, $instance)
	{
		extract( $args );
		echo $before_widget;
		echo $before_title . $instance['title'] . $after_title;
		
		if(!eko_guestbook_db_check())
		{
			_e('The database is outdated.','eko');
		}
		else
		{
			//incio do loop
			$sql = "SELECT * FROM ".EKO_DB_PREFIX."eko_guestbook WHERE status = 1 ORDER BY id DESC LIMIT 3";
			if($rs=mysql_query($sql))
			{
				$i=0;
				echo "<ul>";
				while($arr=mysql_fetch_array($rs))
				{
					?>
					<li><a href="<?=eko_get_page_url("eko_guestbook")?>"><b><?=$arr['nome'];?>:</b> <?=$arr['msg'];?></a></li>
					<?
					$i++;
				};
				?>
                <li><a href="<?=eko_get_page_url("eko_guestbook")?>"><b><? _e('[+] Leave your message!','eko');?></b></a></li>
                <?
				echo "</ul>";
			}
			else
			{
				_warning(__('Error:','eko'),"<li>".mysql_query()."</li>");
			};
			//fim do loop
		};
		echo $after_widget;
    }

    function update($new_instance, $old_instance)
	{				
        return $new_instance;
    }

    function form($instance)
	{				
        $title = esc_attr($instance['title']);
        ?>
            <p>
            	<label for="<?php echo $this->get_field_id('title'); ?>">
					<?php _e('Title:','eko'); ?> 
                    <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
                </label>
            </p>
        <?php 
    }

} // class eko_guestbook_widget_lastmessages
add_action('widgets_init', create_function('', 'return register_widget("eko_guestbook_widget_lastmessages");'));
//-------------


add_action("eko_css","eko_guestbook_css");
?>